<p>Jezik VHDL dolazi s vrlo malo izravno ugrađenih tipova podataka. Od njih, najjednostavniji je tip imena <code>bit</code>.
   Signali i varijable koje definiramo da su tipa <code>bit</code> mogu poprimiti jednu od sljedeće dvije vrijednosti: <code>'0'</code> ili <code>'1'</code>.
   Primijetite da se vrijednosti pišu pod jednostrukim navodnicima.
</p>

<p>Skup signala ovog tipa moguće je definirati tipom <code>bit_vector</code>. Primjerice, trobitni signal ovog tipa mogao bi poprimiti bilo koju
   od vrijednosti: <code>"000"</code>, <code>"001"</code>, <code>"010"</code>, <code>"011"</code>,
   <code>"100"</code>, <code>"101"</code>, <code>"110"</code> odnosno <code>"111"</code>.
   Primijetite da se vrijednosti pišu pod dvostrukim navodnicima.
</p>

<p>Nad ovim tipovima definirano je 7 logičkih operatora.</p>

<div class="mlTableCaption"><span class="mlTblKey">Tablica 1.</span> Djelovanje logičkih operatora nad tipom <code>bit</code> odnosno <code>bit_vector</code>.</div>
<table class="mlTableCC mlTableVRl1 mlTableVRl2 mlTableCC2 mlTableCCC">
<tr><th>Operator</th><th>Opis</th><th>Primjeri</th></tr>
<tr>
  <td><code>not</code></td>
  <td>Logičko NE</td>
  <td>
    <code>not '0'</code> daje <code>'1'</code><br>
    <code>not '1'</code> daje <code>'0'</code><br>
    <code>not "1010"</code> daje <code>"0101"</code><br>
  </td>
</tr>
<tr>
  <td><code>and</code></td>
  <td>Logičko I</td>
  <td>
    <code>'0' and '0'</code> daje <code>'0'</code><br>
    <code>'0' and '1'</code> daje <code>'0'</code><br>
    <code>'1' and '0'</code> daje <code>'0'</code><br>
    <code>'1' and '1'</code> daje <code>'1'</code><br>
    <code>"1010" and "0110"</code> daje <code>"0010"</code><br>
  </td>
</tr>
<tr>
  <td><code>or</code></td>
  <td>Logičko ILI</td>
  <td>
    <code>'0' or '0'</code> daje <code>'0'</code><br>
    <code>'0' or '1'</code> daje <code>'1'</code><br>
    <code>'1' or '0'</code> daje <code>'1'</code><br>
    <code>'1' or '1'</code> daje <code>'1'</code><br>
    <code>"1010" or "0110"</code> daje <code>"1110"</code><br>
  </td>
</tr>
<tr>
  <td><code>nand</code></td>
  <td>Logičko NI</td>
  <td>
    <code>'0' nand '0'</code> daje <code>'1'</code><br>
    <code>'0' nand '1'</code> daje <code>'1'</code><br>
    <code>'1' nand '0'</code> daje <code>'1'</code><br>
    <code>'1' nand '1'</code> daje <code>'0'</code><br>
    <code>"1010" nand "0110"</code> daje <code>"1101"</code><br>
  </td>
</tr>
<tr>
  <td><code>nor</code></td>
  <td>Logičko NILI</td>
  <td>
    <code>'0' nor '0'</code> daje <code>'1'</code><br>
    <code>'0' nor '1'</code> daje <code>'0'</code><br>
    <code>'1' nor '0'</code> daje <code>'0'</code><br>
    <code>'1' nor '1'</code> daje <code>'0'</code><br>
    <code>"1010" nor "0110"</code> daje <code>"0001"</code><br>
  </td>
</tr>
<tr>
  <td><code>xor</code></td>
  <td>Logičko Isključivo-ILI</td>
  <td>
    <code>'0' xor '0'</code> daje <code>'0'</code><br>
    <code>'0' xor '1'</code> daje <code>'1'</code><br>
    <code>'1' xor '0'</code> daje <code>'1'</code><br>
    <code>'1' xor '1'</code> daje <code>'0'</code><br>
    <code>"1010" xor "0110"</code> daje <code>"1100"</code><br>
  </td>
</tr>
<tr>
  <td><code>xnor</code></td>
  <td>Logičko negirano Isključivo-ILI</td>
  <td>
    <code>'0' xnor '0'</code> daje <code>'1'</code><br>
    <code>'0' xnor '1'</code> daje <code>'0'</code><br>
    <code>'1' xnor '0'</code> daje <code>'0'</code><br>
    <code>'1' xnor '1'</code> daje <code>'1'</code><br>
    <code>"1010" xnor "0110"</code> daje <code>"0011"</code><br>
  </td>
</tr>
</table>

<p>U tablici je prikazano djelovanje svakog od operatora nad jednobitnom vrijednošću kao i nad višebitnom vrijednošću.
U slučaju da su argumenti višebitne vrijednosti, oba moraju biti jednake širine, i tada je rezultat višebitna vrijednost
iste širine kao i argumenti pri čemu se <em>i</em>-ti bit rezultata računa na temelju <em>i</em>-tih bitova argumenata
(kažemo da se rezultat računa zasebno po bitovima).</p>

<p>Imena operatora mogu se pisati malim slovima, velikim slovima ili bilo kakvom kombinacijom.</p>

<div class="mlNote">
 <p>Operatori <code>and</code>, <code>or</code>, <code>xor</code> i <code>xnor</code> su komutativni i asocijativni.</p>
</div>

<p>Budući da su operatori <code>and</code>, <code>or</code>, <code>xor</code> i <code>xnor</code> komutativni i asocijativni, ako se
isti operator primijeni na više argumenata, rezultat će biti isti neovisno o redoslijedu kojim računamo. Stoga VHDL dozvoljava
da se takvi izrazi pišu bez upotrebe zagrada. Primjerice, legalno je napisati: <code>'1' and '0' and '1' and '1'</code>.</p>

<div class="mlNote">
 <p>Operatori <code>nand</code> i <code>nor</code> jesu komutativni ali nisu asocijativni.</p>
</div>

<p>Budući da operatori <code>nand</code> i <code>nor</code> nisu asocijativni, u slučaju da se primjenjuju na više od dva argumenta,
redoslijed izračuna je bitan. Zbog tog razloga, VHDL ne dozvoljava da se taj operator primijeni na više od dva argumenta bez da se redoslijed izračuna odredi
zagradama. Stoga sljedeće nije legalno: <code>'0' nand '1' nand '1'</code>, ali <code>('0' nand '1') nand '1'</code> i 
<code>'0' nand ('1' nand '1')</code> jest. Prvi od ova dva izraza kao rezultat daje <code>'0'</code> dok drugi daje <code>'1'</code>.
</p>

<div class="mlNote">
 <p>Operatori <code>and</code>, <code>or</code>, <code>xor</code>, <code>xnor</code>, <code>nand</code> i <code>nor</code>
jednakog su prioriteta. Operator <code>not</code> većeg je prioriteta.</p>
</div>

<p>Kako su operatori <code>and</code>, <code>or</code>, <code>xor</code>, <code>xnor</code>, <code>nand</code> i <code>nor</code>
jednakog prioriteta, <strong>ne smije</strong> ih se miješati bez zagrada. Sljedeće nije legalno: <code>'1' and '0' or '1'</code>,
dok <code>('1' and '0') or '1'</code> odnosno <code>'1' and ('0' or '1')</code> jest. Budući da je negacija najvećeg
prioriteta, sljedeća dva izraza oba su legalna i rezultiraju jednakom vrijednošću: <code>'1' or not '0' or '1'</code>, <code>'1' or (not '0') or '1'</code>.</p>

